package com.cringe_studios.cringe_authenticator_library;

public interface OTP {
	//TOTP
	//HOTP
	
	protected String secret;
	protected OTPType type;
	protected OTPAlgorithm algorithm;
	protected long digits;
	protected long counter;
	protected long period;
	
	//secret: required
	//algorithm: optional (default SHA1)
	//digits: optional (default 6)
	//OTPType: required
	//period: optional (default 30)
	//counter: required if hotp
	public static OTP createNewOTP(OTPType type, String secret, OTPAlgorithm algorithm, long digits, long counter, long periodInSeconds) {
		return null;
	}
	
	public long getNextDueTime();
	
	public String getPin();
	
	public String updatePin();
	
	default public String getSecret() {
		return this.secret;
	}
	
	default public OTPType getOTPType() {
		return this.type;
	}
	
	default public OTPAlgorithm getAlgorithm() {
		return algorithm;
	}
	
	default public long getDigits() {
		return this.digits;
	}
	
	default public long getCounter() {
		return this.counter;
	}
	
	default public long getPeriod() {
		return this.period;
	}
}